module.exports = {

    /**
     *
     * @param {object} target
     * @param {number} jumpDist
     * @param {number} timeDelay
     * @param {object} contextScene
     * @param {number} repeat
     * @param {object} scene
     * @param {object} level
     */
    animationWinLevel : function(target,jumpDist,timeDelay,contextScene,repeat,scene,level){
        contextScene.tweens.add({
            delay:timeDelay,
            repeat:repeat,
            yoyo:true,
            targets:target,
            y:{getEnd: () => {return target.y + jumpDist} },
            onComplete: ()=>{
                if (repeat != -1){
                    if (level == 2) {
                        scene.restart(level);
                    }
                    else{
                        scene.stop(actualScene);
                        document.getElementById('button_return').style.display = 'none';
                        scene.run(previousScene);
                    }
                }
            }
            });
    },

    /**
     *
     * @param {object} target
     * @param {number} jumpDist
     * @param {number} timeDelay
     * @param {object} contextScene
     * @param {number} yBegin
     */
    animationPerso : function(target,jumpDist,timeDelay,contextScene,yBegin){
        return contextScene.tweens.add({
            repeat: -1,
            yoyo: true,
            targets: target,
            y: {
                getStart: () => {
                    return yBegin;
                },
                getEnd: () => {
                    return yBegin + jumpDist;
                }
            },
        });
    },

    /**
     *
     * @param previousLength
     * @param nbForWin
     * @param target
     * @param contextScene
     */
    animationBadClick : function(previousLength,nbForWin,target,contextScene){
        contextScene.tweens.add({
            targets: target,
            alpha:1,
            duration:100,
            repeat: 3,
            onComplete: ()=>{
                if (response.length==previousLength && response.length < nbForWin){
                    target.alpha = 0.3;
                    }
                }
            });
    },

    /**
     *
     * @param element
     * @param soundKey
     * @param animKey
     * @param persoAnim
     * @param speakAnim
     * @param contextScene
     * @param nbFrames
     */
    playSound(element,soundKey,animKey,persoAnim,speakAnim,contextScene){
            /*if (!this.anims.anims.has('speak')){    //cree l'animation globale du perso qui parle(bouge la bouche)
                this.anims.create({key:'speak',frames:this.anims.generateFrameNames(mPersoSpeak.persoAnimKey, { start: 0, end: 1 }),repeat:3, yoyo:true});
            }*/
            var markerelement = { name: element.markerName, start: element.start, duration: element.duration, config: {} };
            mAnimation.persoSpeak(element,animKey,persoAnim,speakAnim);
            contextScene.sound.play(soundKey, markerelement);
    },

    /**
     *
     * @param element
     * @param animKey
     * @param persoAnim
     * @param speakAnim
     */
    persoSpeak(element,animKey,persoAnim,speakAnim){
        persoAnim.play(animKey);
        //speakAnim.setFrame(element.keySpeak);
        //speakAnim.setTint(element.tint);
    },

    /**
     *
     * @param listButtons
     * @param contextScene
     */
    moveGameChoice(listButtons,contextScene){
        contextScene.tweens.add({
            delay:500,
            repeat:-1,
            yoyo:true,
            targets:listButtons,
            y:{getEnd: function(target,key,value){return target.y -20} },
        });
    },

    /**
     *
     * @param train
     * @param contextScene
     */
    moveTrain(contextScene){
        contextScene.tweens.add({
            targets: contextScene.fTrain,
            x:{value:contextScene.fTrain.width/2-DEFAULT_WIDTH/4,ease:'Circ.easeOut'},
            y:contextScene.fTrain.y,
            onComplete: ()=>
            {
                for (var i =0;i<contextScene.fTrain.list.length;i++){
                    //contextScene.setMoveParamObject(contextScene.fTrain.list[i]);
                    contextScene.fTrain.list[i].setInteractive();
                }
                contextScene.setMoveParamObject(contextScene.fTrain);
                contextScene.fInpiu.setInteractive();
                contextScene.fTrasmetta.setInteractive();
                contextScene.fTutoClick = contextScene.add.image(bddJeu['Home'].beginPersoPos[0], 0, bddJeu['Tuto'].tutoHand);
                contextScene.fTutoClick.setScale(bddJeu['Tuto'].scaleHand);
                contextScene.fTutoClick.depth = 50;
                mAnimation.animationTutoDrag(contextScene);
            }
        });
    },

    /**
     *
     * @param perso
     * @param contextScene
     */
    movePersoHome(perso,contextScene){
        contextScene.tweens.add({
            targets: perso,
            x: perso.x,
            y: bddJeu['Home'].endPersoMoveY,
            onComplete: ()=>
            {
                //contextScene.setMoveParamObject(perso);
                //perso.setInteractive();
                contextScene.setMoveParamObject(contextScene.fPerso_HD);
                contextScene.fPerso_HD.setInteractive();
            }
        });
    },

    /**
     *
     * @param perso
     * @param contextScene
     * @param x
     * @param y
     */
    movePersoToTrain(perso,contextScene,x,y){

        //mSongManage.url = "assets/son/click.mp3";
        mSongManage.loadClick(contextScene);
        contextScene.tweens.add({
            targets: perso,
            x: {value: x, ease:'Circ.easeOut'},
            y: {value: y, ease:'Circ.easeOut'},
            onComplete: ()=>
            {
                mAnimation.animationTrain(contextScene);
            }
        });
    },

    /**
     * deplacement de la coccinelle qui traverse l'ecran durant toute la comptine
     * @param contextScene
     * @param object
     * @param music
     * @param button
     * @param xBegin
     * @param yBegin
     */
    animationPersoSong : (contextScene,object,music,button,xBegin,yBegin) => {

        contextScene.tweens.add({
            duration : music.duration*1000,
            targets: object,
            x: -xBegin,
            onComplete: ()=>
            {
                contextScene.disappearPerso(-xBegin,yBegin,object,button);
            }
        });

    },

    /**
     *
     * @param object
     * @param contextScene
     * @param targetEnd
     */
    animationTutoDrag : (contextScene) => {
        contextScene.tweens.add({
            targets:  contextScene.fTutoClick,
            x: contextScene.fTrain.list[1].body.transform.x,
            y: contextScene.fTrain.list[1].body.transform.y,
            //loop: true,
            repeat:1,
            yoyo: true,
            onComplete: ()=>
             {
                 contextScene.fTutoClick.x = contextScene.fTrain.list[2].body.transform.x+30;
                 contextScene.fTutoClick.y = contextScene.fTrain.list[2].body.transform.y+30;
                 mAnimation.animationTutoClick(contextScene.fTutoClick,contextScene);
             }
        });
    },

    /**
     *
     * @param contextScene
     */
    animationTutoClick : (object,contextScene) => {
        return contextScene.tweens.add({
            targets: object,
            x: object.x-5,
            y: object.y-5,
            repeat:-1,
            yoyo: true
        });
    },


    animationTrain(contextScene){
        contextScene.fTrain.setInteractive(false);
        contextScene.input.setDraggable(contextScene.fTrain,false);
        contextScene.tweens.add({
            delay:500,
            duration:1500,
            totalDuration:1500,
            targets:[contextScene.fPerso_HD,contextScene.fTrain],
            x:{getEnd: (target,key,value) => {return target.x-contextScene.fTrain.width*3/2;}},
            onComplete:() => {contextScene.change("Level",Level)}
        });
    }
};