module.exports = {


    /**
     * genere la partie cliquable des jeux
     * @param {integer} gap (ecart)
     * @param {list} values (liste d'elements)
     * @param {integer} gap (ecart)
     * @param {integer} gap (ecart)
     */
    generateElements : function(gap,frameElement,values,cardFrame,elemVisible,cardsGroup,elemGroup,contextScene,bdd){
        //console.log('LINE',nbLines);
        var cardHeight = frameElement.height;
        var cardWidth = frameElement.width;   //frame = this.textures.get('card1').frames[1]
        var scaleCard = mDisplayInScreen.calculateScaleCards(cardWidth,cardHeight,bddJeu['Cards'].scale);
        cardWidth = cardWidth * scaleCard;
        cardHeight = cardHeight * scaleCard;
        var posStart = mDisplayElement.positionStartGroup(0,0,gap,cardWidth,cardHeight,bddJeu['Game'].nbObjects,bddJeu['Cards'].nbMaxCardsInLine);
        var pos = new Phaser.Math.Vector2(posStart.x,posStart.y);
        var choiceGroup = [];
        var gapY = 0;

        for(var i=0;i<bddJeu['Game'].nbObjects;i++){
            var bddObject = bdd[values[i]];//pour couleur atlas faire un if bddvalues
            var group = mDisplayElement.createContainerCardAndElement(pos,scaleCard,cardFrame,elemVisible,cardsGroup,elemGroup,contextScene,gap,cardWidth,cardHeight,bddObject,i);
            var containerElement = contextScene.add.container(pos.x,pos.y,group);   //container de l'ensemble carte-objets
            containerElement.setSize(cardWidth,cardHeight); //obligatoire pour le clic sur le container, une taille est necessaire
            containerElement.setInteractive();  //option rendant le container interactif, clickable
            gapY = mDisplayElement.generateLine(i,posStart,pos,gap,gapY,cardWidth,cardHeight,bddJeu['Cards'].nbMaxCardsInLine);
            choiceGroup.push(containerElement);
        }
        return(choiceGroup);
    },

    /**
     * Cree une carte et son contenu
     * @param pos
     * @param scaleElem
     * @param cardFrame
     * @param elemVisible
     * @param cardsGroup
     * @param elemGroup
     * @param contextScene
     * @param gap
     * @param cardWidth
     * @param cardHeight
     * @param bddObject
     * @param ind
     * @returns {Array}
     */
    createContainerCardAndElement : (pos,scaleElem,cardFrame,elemVisible,cardsGroup,elemGroup,contextScene,gap,cardWidth,cardHeight,bddObject,ind)=>{
        var card = contextScene.add.sprite(0,0,bddJeu['Cards'].atlasKeyElement,cardFrame);
        card.setScale(scaleElem);
        /*if (cardFrame==1) {*/
            card.setAlpha(0.85);
        /*}*/
        var group = [];
        var nbElement = nbElementInCase[ind];
        group.push(card);
        var elementFrame = mDisplayElement.getFrameOfObject(contextScene,bddObject);
        var scaleElementPNG = mDisplayInScreen.calculateScaleElementInCard(cardWidth,cardHeight,elementFrame.width,elementFrame.height,3);
        mDisplayElement.generateDomino(nbElement,pos,cardWidth,cardHeight,elementFrame.width,elementFrame.height,bddObject,elemVisible,elemGroup,contextScene,group,scaleElementPNG);
        cardsGroup.add(card);
        return(group);
    },

    /**
     *  affecte un element a un groupe avec un parametre de visibilite
     * @param group
     * @param element
     * @param elemVisible
     * @param elemGroup
     */
    affectToGroup : (group,element,elemVisible,elemGroup) =>{
        group.push(element);
        element.setVisible(elemVisible);
        elemGroup.add(element);
    },

    /**
     * recupere la frame d'une texture en fonction de son type : un atlas ou une image
     * @param contextScene
     * @param bddObject
     * @returns {*}
     */
    getFrameOfObject : (contextScene,bddObject) =>{
        var frameElement;
        var atlasKeyElement = bddObject.atlasKeyElement;
        var elementKey = bddObject.elementKey;
        if (atlasKeyElement.length==0){ //image seule
            frameElement = contextScene.textures.get(elementKey).frames["__BASE"];
        }
        else {  //atlas
            frameElement = contextScene.textures.get(atlasKeyElement).frames[elementKey];
        }
        return(frameElement)
    },

    /**
     *
     * @param pos
     * @param bddObject
     * @param contextScene
     * @param scaleElementPNG
     * @returns {*|Phaser.Physics.Matter.Sprite|Phaser.Physics.Impact.ImpactSprite|Phaser.Physics.Arcade.Sprite}
     */
    displayObjectInGame : (pos,bddObject,contextScene,scaleElementPNG)=>{
        var atlasKeyElement = bddObject.atlasKeyElement;
        var elementKey = bddObject.elementKey;
        if (atlasKeyElement.length==0){
            var element = contextScene.add.sprite(pos.x,pos.y,elementKey,"__BASE");
            }
        else{
            var element = contextScene.add.sprite(pos.x,pos.y,atlasKeyElement,elementKey);
            }
        element.setScale(scaleElementPNG);
        return(element);
    },

    /**
     * place une ligne d'element et retourne la position de la ligne suivante
     * @param nbLines
     * @param i
     * @param posStart
     * @param pos
     * @param gap
     * @param gapY
     * @param frameWidth
     * @param frameHeight
     * @param nbMaxInLine
     * @returns {*}
     */
    generateLine : (i,posStart,pos,gap,gapY,frameWidth,frameHeight,nbMaxInLine)=>{
        pos.x = pos.x + (gap+frameWidth);
        if ((i+1)%(nbMaxInLine) == 0){
            gapY = gapY + gap+frameHeight;
            pos.y = posStart.y + gapY;
            pos.x = posStart.x;
        }
        return (gapY);
    },

    /**
     * genere l'affichage en 'domino'
     * @param nbElement
     * @param pos
     * @param cardWidth
     * @param cardHeight
     * @param frameWidth
     * @param frameHeight
     * @param bddObject
     * @param elemVisible
     * @param elemGroup
     * @param contextScene
     * @param group
     * @param scaleElementPNG
     */
    generateDomino : (nbElement,pos,cardWidth,cardHeight,frameWidth,frameHeight,bddObject,elemVisible,elemGroup,contextScene,group,scaleElementPNG)=>{
        var nbDivElem = 2.9; //par defaut disposition en domino (3 emplacements dans une ligne d'une carte)
        var posDomino = new Phaser.Math.Vector2(0,0);
        pos = new Phaser.Math.Vector2(posDomino.x,posDomino.y);
        if (nbElement%2==1){
            if (nbElement==1){
                //nbDivElem = 1.5;    //1 element dans une carte (0.5 en plu pour afficher l'element en plus gros)
                nbDivElem = 1.2;
            }
            scaleElementPNG = mDisplayInScreen.calculateScaleElementInCard(cardWidth,cardHeight,frameWidth,frameHeight,nbDivElem);
            var element = mDisplayElement.displayObjectInGame(pos,bddObject,contextScene,scaleElementPNG); //lorsqu'il un nombre impair d'elements, un des elements est centre
            //element.setScale(scaleElementPNG);  //met à l'echelle l'élément
            mDisplayElement.affectToGroup(group,element,elemVisible,elemGroup);
            nbElement = nbElement-1;
            }
        else{
            if (nbElement/3<2){
                nbDivElem = 2;  // 2 elements dans une carte 2.2
            }
            scaleElementPNG = mDisplayInScreen.calculateScaleElementInCard(cardWidth,cardHeight,frameWidth,frameHeight,nbDivElem)
        }
        frameWidth = frameWidth * scaleElementPNG;
        frameHeight = frameHeight * scaleElementPNG;
        var gapx = (cardWidth - frameWidth*(9/nbDivElem))/(9/nbDivElem+0.25);    //0.25 pour la place de l'ecart entre les elements
        var gapy = (cardHeight - frameHeight*(9/nbDivElem))/(9/nbDivElem+0.25);  //0.25 pour la place de l'ecart entre les elements
        var xi = -1;
        var yi = -1;
        var i=1;
        var element;
        while (i<=(nbElement)/2) {
            pos.set((xi) * (gapx + frameWidth),(yi) * (gapy + frameHeight));
            element = mDisplayElement.displayObjectInGame(pos,bddObject,contextScene,scaleElementPNG);
            mDisplayElement.affectToGroup(group, element, elemVisible, elemGroup);
            pos.set(- (xi) * (gapx + frameWidth), - (yi) * (gapy + frameHeight));
            element = mDisplayElement.displayObjectInGame(pos,bddObject,contextScene,scaleElementPNG);
            mDisplayElement.affectToGroup(group, element, elemVisible, elemGroup);
            xi = Math.trunc((i) / 3) - 1;
            yi = (3 - (i)) - 1;
            i = i + 1;
        }

    },

    /**
     * permet de changer la couleur d'un ensemble d'element : ne sert plus
     * @param group
     * @param nbElem
     * @param orderElement
     * @param bdd
     */
    tintElement : function(group,nbElem,orderElement,bdd){
        for (var i=0;i<nbElem;i++){
            group.children.entries[i].setTint(bdd[orderElement[i]].tint);
            }
    },

    /**
     * ajoute la taille de chacun des elements (TODO a modifier, enlever la difference pour avoir la bonne taille)
     * @param arrayObject
     * @returns {Array|[number,number]}
     */
    setSizeOfArrayObject : (arrayObject)=>{
        sizeArray = [0,0];
        for (var i = 0; i<arrayObject.length;i++){
            sizeArray[0] += arrayObject[i].width;
            sizeArray[1] += arrayObject[i].height;
        }
        return(sizeArray);
        },

    /**
     * position de depart d'un ensemble d'elements
     * @param nbLines
     * @param posX
     * @param posY
     * @param gap
     * @param elementWidth
     * @param elementHeight
     * @param nbElements
     * @param nbMaxInLine
     */
    positionStartGroup : (posX,posY,gap,elementWidth,elementHeight,nbElements,nbMaxInLine)=>{
        var nbColumns = Math.min(nbMaxInLine,nbElements);
        var nbLines = mDisplayElement.nbLineCalcul(nbMaxInLine,nbElements);
        var posStart = new Phaser.Math.Vector2(-(((nbColumns/2)-0.5)*(gap+elementWidth))+posX,-(((nbLines/2)-0.5)*(gap+elementHeight))+posY);
        return(posStart);
        },

    /**
     * retourne le nombre de ligne pour un nombre d'elements et un nombre max dans la ligne defini
     * @param nbMaxInLine
     * @param nbElements
     * @returns {number}
     */
    nbLineCalcul : (nbMaxInLine,nbElements)=>{
        return(Math.trunc((nbElements-1)/nbMaxInLine)+1);
        }
};